<template>
  <v-timeline
    align="start"
    :truncate-line="truncateLine"
    side="start"
    :line-inset="lineInset"
    :line-thickness="lineThickness"
  >
    <template #default>
      <v-timeline-item
        v-for="(item, index) in items"
        :key="item.id"
        :dot-color="dotColor"
        fill-dot
        :size="size"
        class="h-full"
      >
        <template #icon>
          <div :class="item.state === 'in_progress' ? 'bg-white w-7 h-7 rounded-full' : 'cursor-pointer'" />
        </template>
        
        <template #default>
          <div class="relative">
            <div>
              <slot name="title" :item="item">
                {{ item?.title }}
              </slot>
            </div>

            <div v-if="index !== items?.length - 1" class="max-w-[100px] truncate h-full flex items-center justify-center absolute left-1/2 z-[100]">
              <slot name="centerItem" :item="item" />
            </div>
          </div>
        </template>

        <template #opposite>
          <div v-if="index < indexStep" class="w-full h-full flex flex-col justify-center items-center ml-[25px]">
            <slot name="block" :item="item">
              <p>Timeline item</p>
              <p>Timeline item</p>
              <p>Timeline item</p>
              <p>Timeline item</p>
              <p>Timeline item</p>
            </slot>
          </div>
        </template>
      </v-timeline-item>
    </template>
 </v-timeline>
</template>

<script setup>
import { ref } from "vue";

const props = defineProps({
  items: { type: Object, default: () => [] },
  truncateLine: { type: String, default: null },
  lineThickness: { type: Number, default: 1 },
  lineInset: { type: Number, default: 1 },
  size: { type: String, default: "small" },
  dotColor: { type: String, default: 'primary' },
})

const indexStep = ref(props.items.length - 1)

</script>

<style>
.v-timeline-item__body {
  height: 100%;
}

.v-timeline-item__body > div {
  height: 100%;
}

.v-timeline-item__opposite {
  display: flex;
  align-items: center !important;
  justify-content: center !important;
  height: 100%;
  margin-top: 25px;
}
</style>